/* OBIETTIVI:
- COMPRENSIONE DEI CONCETTI DI CLASSE E ISTANZA: 
  1. INIZIALIZZATORI STATICI (DI CLASSE) E D'ISTANZA 
  2. VARIABILI STATICHE (DI CLASSE)
- METODO public String toString()

Cosa viene stampato dal seguente programma? */


public class Esercizio1
{
   private static String nome = "Carlo"; 
   private String cognome;
   int id;
   static int c=0;


   public Esercizio1(String cognome) {
	this.cognome=cognome;
        System.out.println(this);
   }

   {	
	id=++c;
   }


   static {
	nome = "Giovanna";
	System.out.println("\n Nome: " + nome);
   }



   public String toString(){
	return id + ") " + nome + " " + cognome;
   }


   public static void main(String args[]) {
     Esercizio1 ogg1, ogg2, ogg3;
     ogg1=new Esercizio1("Bianchi");
     ogg2=new Esercizio1("Rossi");
     ogg3=new Esercizio1("Neri");
     System.out.println("******** nome modificato: ********");
     ogg2.nome="Carlo";
     System.out.println(ogg1);
     System.out.println(ogg2);
     System.out.println(ogg3);
   }

}

/* NB:
 * id potrebbe essere usato per assegnare un codice numerico univoco ad ogni istanza
 * c  potrebbe essere usato per contare il numero di istanze generate
*/


/**********************************************
RIPASSO: QUANDO VIENE CREATO UN OGGETTO
1. SI INIZIALIZZANO LE VARIABILI D'ISTANZA
2. (NB:SOLO LA PRIMA VOLTA QUANDO VIENE CARICATA LA CLASSE) SI ESEGUE L'INIZIALIZZATORE DI CLASSE O STATICO
3. SI ESEGUE L'INIZIALIZZATORE D'ISTANZA
   (blocco di istruzioni esterno a tutti i metodi che viene usato per condividere
    eventuali parti consistenti di codice condiviso da tutti i costruttori)
4. SI INVOCA IL COSTRUTTORE ADEGUATO, SE ESISTE
**********************************************/
 